Attribute VB_Name = "Apci8394w"
'===================================================================
' Apci8394w.bas
'
' aPCI-8394
'
' Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'===================================================================
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const APCI8394_DLL_NAME = "Apci8394.dll"         ' DLL
Dim hDLL As Long                                        ' DLLւ̃nh
Global Const APCI8394_ERR_WRAPDLL = -1                  ' bp[֐G[

'===================================================================
'       Apci8394.dll [h
'       
' ߂l  True
'        s False
'===================================================================
Function Apci8394wDllOpen() As Boolean
    Apci8394wDllOpen = False
    If hDLL <> 0 Then Exit Function
    hDLL = LoadLibrary(APCI8394_DLL_NAME)
    If hDLL = 0 Then Exit Function
    If Apci8394wGetDllExportFunc() = False Then
        Apci8394wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If
    Apci8394wDllOpen = True
End Function
'===================================================================
'       Apci8394.dllA[h
'       
' ߂l  True
'        s False
'===================================================================
Function Apci8394wDllClose() As Boolean
    Apci8394wDllClose = True
    If hDLL = 0 Then Exit Function
    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Apci8394wDllClose = False
End Function
'===================================================================
'    o[Wԍ擾
'    pdwDllVer  DLLo[Wԍi[
'        pdwDrvVer  DRVo[Wԍi[
' ߂l  True
'        s False
'===================================================================
Function Apci8394wGetVersion(ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Boolean
    Apci8394wGetVersion = False
    If hDLL = 0 Then Exit Function
    If Apci8394GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function
    Apci8394wGetVersion = True
End Function
'===================================================================
'    foCX̎gp錾
'    pwLogSlot gpfoCXi[
' ߂l  True
'        s False
'===================================================================
Function Apci8394wCreate(ByRef pwLogSlot As Integer) As Boolean
    Apci8394wCreate = False
    If hDLL = 0 Then Exit Function
    If Apci8394Create(pwLogSlot) = 0 Then Exit Function
    Apci8394wCreate = True
End Function
'===================================================================
'    foCX̊J
'    wLogSlot   gpfoCX
' ߂l  True
'        s False
'===================================================================
Function Apci8394wClose(ByVal wLogSlot As Integer) As Long
    Apci8394wClose = False
    If hDLL = 0 Then Exit Function
    If Apci8394Close(wLogSlot) = 0 Then Exit Function
    Apci8394wClose = True
End Function
'===================================================================
'    wfoCX̃\[X擾
'    wLogSlot   foCX
'        pres       \[Xi[\
' ߂l  True
'        s False
'===================================================================
Function Apci8394wGetResource(ByVal wLogSlot As Integer, ByRef pres As APCI8394RESOURCE) As Boolean
    Apci8394wGetResource = False
    If hDLL = 0 Then Exit Function
    If Apci8394GetResource(wLogSlot, pres) = 0 Then Exit Function
    Apci8394wGetResource = True
End Function
'===================================================================
'    [h
'    wLogSlot   foCX
'        wPort      |[gԍ ( 0,2,4,6 )
'        pwData     ̓f[^i[̈ւ̃|C^
' ߂l  True
'        s False
'===================================================================
Function Apci8394wInpw(ByVal wLogSlot As Integer, ByVal wPort As Integer, ByRef pwData As Integer) As Boolean
    Apci8394wInpw = False
    If hDLL = 0 Then Exit Function
    If Apci8394Inpw(wLogSlot, wPort, pwData) = 0 Then Exit Function
    Apci8394wInpw = True
End Function
'===================================================================
'    [ho
'    wLogSlot   foCX
'        wPort      |[gԍ ( 0,2,4,6 )
'        wData      o̓f[^
' ߂l  True
'        s False
'===================================================================
Function Apci8394wOutpw(ByVal wLogSlot As Integer, ByVal wPort As Integer, ByVal wData As Integer) As Boolean
    Apci8394wOutpw = False
    If hDLL = 0 Then Exit Function
    If Apci8394Outpw(wLogSlot, wPort, wData) = 0 Then Exit Function
    Apci8394wOutpw = True
End Function
'===================================================================
'    gkrǂݍ
'    wLogSlot   foCX
'        wAdr       AhX
'        pwData     ǂݍݒli[̈ւ̃|C^
' ߂l  True
'        s False
'===================================================================
Function Apci8394wMemRead(ByVal wLogSlot As Integer, ByVal wAdr As Integer, ByRef pwData As Integer) As Boolean
    Apci8394wMemRead = False
    If hDLL = 0 Then Exit Function
    If Apci8394MemRead(wLogSlot, wAdr, pwData) = 0 Then Exit Function
    Apci8394wMemRead = True
End Function
'===================================================================
'    gkr
'    wLogSlot   foCX
'        wAdr       AhX
'        wData      ݒl
' ߂l  True
'        s False
'===================================================================
Function Apci8394wMemWrite(ByVal wLogSlot As Integer, ByVal wAdr As Integer, ByVal wData As Integer) As Boolean
    Apci8394wMemWrite = False
    If hDLL = 0 Then Exit Function
    If Apci8394MemWrite(wLogSlot, wAdr, wData) = 0 Then Exit Function
    Apci8394wMemWrite = True
End Function
'===================================================================
'    gkr
'    wLogSlot   foCX
' ߂l  True
'        s False
'===================================================================
Function Apci8394wInitialize(ByVal wLogSlot As Integer) As Boolean
    Apci8394wInitialize = False
    If hDLL = 0 Then Exit Function
    If Apci8394Initialize(wLogSlot) = 0 Then Exit Function
    Apci8394wInitialize = True
End Function
'===================================================================
'    gkrʐMVXeJn
'    wLogSlot   foCX
'        wSNum      ^pTeCg
' ߂l  True
'        s False
'===================================================================
Function Apci8394wStart(ByVal wLogSlot As Integer, ByVal wSNum As Integer) As Boolean
    Apci8394wStart = False
    If hDLL = 0 Then Exit Function
    If Apci8394Start(wLogSlot, wSNum) = 0 Then Exit Function
    Apci8394wStart = True
End Function
'===================================================================
'    gkrʐMVXe~
'    wLogSlot   foCX
' ߂l  True
'        s False
'===================================================================
Function Apci8394wStop(ByVal wLogSlot As Integer) As Boolean
    Apci8394wStop = False
    If hDLL = 0 Then Exit Function
    If Apci8394Stop(wLogSlot) = 0 Then Exit Function
    Apci8394wStop = True
End Function
'===================================================================
'    cGÃAhXɏݎs
'    wLogSlot   foCX
'        wSNo       TeCgm
'        wData      ޒl
' ߂l  True
'        s False
'===================================================================
Function Apci8394wDout(ByVal wLogSlot As Integer, ByVal wSNo As Integer, ByVal wData As Integer) As Boolean
    Apci8394wDout = False
    If hDLL = 0 Then Exit Function
    If Apci8394Dout(wLogSlot, wSNo, wData) = 0 Then Exit Function
    Apci8394wDout = True
End Function
'===================================================================
'    cGA̒lǂݍ
'    wLogSlot   foCX
'        wSNo       TeCgm
'        pwData     ǂݍݒli[̈ւ̃|C^
' ߂l  True
'        s False
'===================================================================
Function Apci8394wDin(ByVal wLogSlot As Integer, ByVal wSNo As Integer, ByRef pwData As Integer) As Boolean
    Apci8394wDin = False
    If hDLL = 0 Then Exit Function
    If Apci8394Din(wLogSlot, wSNo, pwData) = 0 Then Exit Function
    Apci8394wDin = True
End Function
'===================================================================
'    JE^GA̒lǂݍ
'    wLogSlot   foCX
'        wSNo       TeCgm
'        wCntNo     JE^ԍ(1`6)
'        pwData     ǂݍݒli[̈ւ̃|C^
' ߂l  True
'        s False
'===================================================================
Function Apci8394wCntRead(ByVal wLogSlot As Integer, ByVal wSNo As Integer, ByVal wCntNo As Integer, ByRef pwData As Integer) As Boolean
    Apci8394wCntRead = False
    If hDLL = 0 Then Exit Function
    If Apci8394CntRead(wLogSlot, wCntNo, wSNo, pwData) = 0 Then Exit Function
    Apci8394wCntRead = True
End Function
'===================================================================
'    f[^WX^GA̒lǂݍ
'    wLogSlot   foCX
'        wSNo       TeCgm
'        pwData     ǂݍݒli[̈ւ̃|C^
' ߂l  True
'        s False
'===================================================================
Function Apci8394wDRegRead(ByVal wLogSlot As Integer, ByVal wSNo As Integer, ByRef pwData As Integer) As Boolean
    Apci8394wDRegRead = False
    If hDLL = 0 Then Exit Function
    If Apci8394DRegRead(wLogSlot, wSNo, pwData) = 0 Then Exit Function
    Apci8394wDRegRead = True
End Function
'===================================================================
'    Rg[GAɃR}h
'    wLogSlot   foCX
'        wSNo       TeCgm
'        wCmd       R}h
' ߂l  True
'        s False
'===================================================================
Function Apci8394wCtrlWrite(ByVal wLogSlot As Integer, ByVal wSNo As Integer, ByVal wCmd As Integer) As Boolean
    Apci8394wCtrlWrite = False
    If hDLL = 0 Then Exit Function
    If Apci8394CtrlWrite(wLogSlot, wSNo, wCmd) = 0 Then Exit Function
    Apci8394wCtrlWrite = True
End Function
'===================================================================
'    Rg[GAǂݍ
'    wLogSlot   foCX
'        wSNo       TeCgm
'        pwValue    ǂݍݒli[̈ւ̃|C^
' ߂l  True
'        s False
'===================================================================
Function Apci8394wCtrlRead(ByVal wLogSlot As Integer, ByVal wSNo As Integer, ByRef pwValue As Integer) As Boolean
    Apci8394wCtrlRead = False
    If hDLL = 0 Then Exit Function
    If Apci8394CtrlRead(wLogSlot, wSNo, pwValue) = 0 Then Exit Function
    Apci8394wCtrlRead = True
End Function
'===================================================================
'    G[R[h擾
'    wLogSlot       foCX
' ߂l  True
'        s False
'===================================================================
Function Apci8394wGetLastError(ByVal wLogSlot As Integer) As Long
    Apci8394wGetLastError = APCI8394_ERR_WRAPDLL
    If hDLL = 0 Then Exit Function
    Apci8394wGetLastError = Apci8394GetLastError(wLogSlot)
End Function
'-------------------------------------------------------------------
'    DLLGNX|[g֐AhX̎擾
'    
' ߂l  True
'        s False
'-------------------------------------------------------------------
Private Function Apci8394wGetDllExportFunc() As Boolean
    Dim pFunc As Long

    Apci8394wGetDllExportFunc = False

    pFunc = GetProcAddress(hDLL, "Apci8394GetVersion")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394GetVersion")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394Create")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394Close")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394GetResource")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394GetLastError")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394Inpw")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394Outpw")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394MemRead")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394MemWrite")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394Initialize")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394Start")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394Stop")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394Dout")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394Din")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394CntRead")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394DRegRead")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394CtrlWrite")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8394CtrlRead")
    If pFunc = 0 Then Exit Function


    Apci8394wGetDllExportFunc = True ' SĂ DLL GNX|[g֐݂̑mF

End Function

