/*****************************************************************************/
/*	apci8394w.h																 */
/*																			 */
/*	aPCI-8394															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1999/05/26															 */
/*																			 */
/*****************************************************************************/

#ifndef __INC_APCI8394W_H__
#define __INC_APCI8394W_H__

#include "apci8394.h"


#ifdef __cplusplus
extern "C"{
#endif


#define APCI8394_DLL_NAME	  _T("apci8394.dll")	// DLL

#define APCI8394_ERR_WRAPDLL ((DWORD)-1)	// bp[֐G[


BOOL  Apci8394wDllOpen();		// DLL [h
BOOL  Apci8394wDllClose();		// DLL A[h

BOOL  Apci8394wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDrvVersion);
BOOL  Apci8394wCreate(PWORD pwLogSlot);
BOOL  Apci8394wClose(WORD wLogSlot);
BOOL  Apci8394wGetResource(WORD wLogSlot, PAPCI8394R pres);
BOOL  Apci8394wInpw(WORD wLogSlot, WORD wPort, PWORD pwData);
BOOL  Apci8394wOutpw(WORD wLogSlot, WORD wPort, WORD wData);
BOOL  Apci8394wMemRead(WORD wLogSlot, WORD wAdr, PWORD pwData);
BOOL  Apci8394wMemWrite(WORD wLogSlot, WORD wAdr, WORD wData);
BOOL  Apci8394wInitialize(WORD wLogSlot);
BOOL  Apci8394wStart(WORD wLogSlot, WORD wSNum);
BOOL  Apci8394wStop(WORD wLogSlot);
BOOL  Apci8394wDout(WORD wLogSlot, WORD wSNo, WORD wData);
BOOL  Apci8394wDin(WORD wLogSlot, WORD wSNo, PWORD pwData);
BOOL  Apci8394wCntRead(WORD wLogSlot, WORD wSNo, WORD wCntNo, PWORD pwData);
BOOL  Apci8394wDRegRead(WORD wLogSlot, WORD wSNo, PWORD pwData);
BOOL  Apci8394wCtrlWrite(WORD wLogSlot, WORD wSNo, WORD wCmd);
BOOL  Apci8394wCtrlRead(WORD wLogSlot, WORD wSNo, PWORD pwValue);
DWORD Apci8394wGetLastError(WORD wLogSlot);


#ifdef __cplusplus
}
#endif

#endif // __INC_APCI8394W_H__
